
function resImg = KernelNxM_const(img,y,x,n,m,const)

%Function Kernel NxM const
%returns a NxM window (a subimage at y,x)
% n, m must be even!
% if the window is outside the image, the pixels outside the image 
% will be set to the const-parameter
%----------------------------------------------------
%    Written by Hamid Sarve
%    2006-06-14
%----------------------------------------------------
%PLEASE NOTE!
%The implementation is quite bad (slow) but it works


ImgWidth  = size(img,2); %get the image size
ImgHeight = size(img,1); %get the image size
ImgComps  = size(img,3); %get the nr of components
resImg    = zeros(n,m,ImgComps); %result img
mrgY      = floor(n/2);  %offset from the center position
mrgX      = floor(m/2);


if( (x+m) >= ImgWidth || (x-m) < 1 || (y-n) < 1 || (y+n)>= ImgHeight)
%the window is outside the image

    for kz=1:ImgComps %for all components,   
        for ky=1:n,
            for kx=1:m,

                %---------------X---------------
                cordX =  (x-2) +kx-floor(m/2);
                x_mod = cordX;
                cordY = (y-2)+ky-floor(n/2);
                y_mod = cordY;

                %case cordX outside of the image            
                if(cordX>= ImgWidth || cordX < 0 || cordY < 0 || cordY>= ImgHeight)
                         resImg(ky,kx,kz) = const;   
                else
                         resImg(ky,kx,kz) = img(y_mod+1,x_mod+1,kz);
                end


            end

        end
    end

else
    %just return the window
    resImg = img(y-mrgY:y+mrgY,x-mrgX:x+mrgX,:);
end



