function [GradientImage init_y init_x]=  MarkConnectivity(ContourImage,  horizontal)
%{
   marks the connectivity of the contour
   Direction-setting:
   4 bits
   N S E W
   example
   NW:
   N S E W
   0 1 0 1 = 5
%}
ImgWidth  = size(ContourImage,2); %get the image size
ImgHeight = size(ContourImage,1); %get the image size


index = 0;

[y x] = find(ContourImage == 1);

NrOfPixels = size(x,1);

for i=1:NrOfPixels,
    Kernel      = KernelNxM_const(ContourImage,y(i),x(i),3,3,0);
    if(sum(sum(Kernel)) == 2)
       index         = index + 1;
       cand_init_x(index) = x(i);
       cand_init_y(index) = y(i);
    end

end

init_x = cand_init_x(1);
init_y = cand_init_y(1);

for i=1:size(cand_init_x,2),
    if(horizontal)
        if(cand_init_x(i)  < init_x)
            init_x = cand_init_x(i);
            init_y = cand_init_y(i);
        end
    else
         if(cand_init_y(i) < init_y)
            init_x = cand_init_x(i);
            init_y = cand_init_y(i);
        end
    end
end

 
new_x = init_x;
new_y = init_y;

GradientImage = zeros(ImgHeight,ImgWidth);

 

for i=1:NrOfPixels-1,
   Kernel                = KernelNxM_const(ContourImage,new_y,new_x,3,3,0);
   Kernel(2,2)           = 0;
   [offset_y offset_x]   = find(Kernel == 1);

   %{
   Direction-setting:
   4 bits
   N S E W
   example
   NW:
   N S E W
   0 1 0 1 = 5
   %}
   %offset_y
   %offset_x
   %new_y
   %new_x
   if(offset_y(1) == 1 && offset_x(1) == 1) value = 9; end
   if(offset_y(1) == 1 && offset_x(1) == 2) value = 8; end
   if(offset_y(1) == 1 && offset_x(1) == 3) value = 10; end

   if(offset_y(1) == 2 && offset_x(1) == 1) value = 1; end
   if(offset_y(1) == 2 && offset_x(1) == 2) value = 0; end
   if(offset_y(1) == 2 && offset_x(1) == 3) value = 2; end

   if(offset_y(1) == 3 && offset_x(1) == 1) value = 5; end
   if(offset_y(1) == 3 && offset_x(1) == 2) value = 4; end
   if(offset_y(1) == 3 && offset_x(1) == 3) value = 6; end
 
  %dont forget to remove
   ContourImage(new_y,new_x) = 0;
   GradientImage(new_y,new_x) =  value;
   new_y = new_y + offset_y-2;
   new_x = new_x + offset_x-2;
end


