% in v.6 the thresholds come from a file, the main ones are saved in a file thStructSaved
% that includes a struct called thStructSaved with fields that are the
% thresholds
% in v.5 I add a calibration step
% main codes used by this code are: measureHypo9
% in v.4 I change the file name handeling for the input and output
% in v.3 we show the measured seedlings
% in v.2 also measure roots length
% batchMeasureHypo1
% this code will run through all the images and analyze the lengths

close all
clear all

%%
tic

% files location
oldDir=pwd;

% cd('E:\arabidopsis\tiff'); % disk on key
% cd('C:\Program Files\MATLAB\R2006a\work\env\ara\tiff'); % office
% cd('C:\Program Files\MATLAB\R2006a\work\env\ara\christine'); % office
% cd('C:\Program Files\MATLAB71\work\env\ara\christine'); % home
% cd('C:\ara'); % home

% g: 330, 331, 338, 340, 342,
% r: 329, 339, 341, 334
% both: 335, 337
% empty: 336, 343
% green is the default
markingColor=2;
% figure

%          subplot(3,3,loopTh) % cancel other figures and add figure

try, % to choose input flies
    [fnameFirst,dataPathCalib] = uigetfile('*.tif','Select the first image to analyze [name format is xxxxYYYY.tif where x can be any character and Y should be a four digit image number');

    startingImage=str2num(fnameFirst(5:8));
    [fnameSecond,dataPathCalib] = uigetfile('*.tif','Select the first image to analyze [name format is xxxxYYYY.tif where x can be any character and Y should be a four digit image number');
    endingImage=str2num(fnameSecond(5:8));
    cd(dataPathCalib);

    try,
        load('thStructSaved.mat')
        thStructStart=thStruct;
        button = questdlg('Use saved thresholds or define manually (may take about 10 minutes','title','use saved','manual','use default')
        if button(1)=='u',
        else,
            % create a 3*3 set of different th with analysis to let the user
            % choose the best th
            for loopTh=1:9,
                % thStruct=

                vect1=[-1 0 1];
                thChangeMat1=repmat(vect1,3,1);
                thChangeMat2=thChangeMat1';
                hypoJump=10;
                rootJump=10;
                hypoThUpdate1;
                thStruct.showValues=1;
                fileName=['DSCN' num2str(startingImage) '.tif'];

                %     figure
                %     subplot(3,3,loopTh) % cancel other figures and add figure
                [lengthHypo, lengthRoots]=measureHypo11(fileName,thStruct,markingColor)
                pause(0.001)

            end;

            % ask the user which image came out best
            answer = inputdlg('which figure is best (1-9)','choose best figure');
            bestFig=str2num(char(answer));
            % use best fig to update the thStruct and save the updated one
            loopTh=bestFig
            hypoThUpdate1;
            save thStructSaved thStruct
        end;

    catch,
        button = questdlg('Use default thresholds or define manually (may take about 10 minutes','title','use default','manual','use default')
        hypoTh1; % if no file use the default values
        thStructStart=thStruct;
        if button(1)=='u',
        else,

            for loopTh=1:9,
                % thStruct=

                vect1=[-1 0 1];
                thChangeMat1=repmat(vect1,3,1);
                thChangeMat2=thChangeMat1';
                hypoJump=10;
                rootJump=10;
                hypoThUpdate1;
                thStruct.showValues=1;
                fileName=['DSCN' num2str(startingImage) '.tif'];

                %     figure
                %     subplot(3,3,loopTh) % cancel other figures and add figure
                [lengthHypo, lengthRoots]=measureHypo11(fileName,thStruct,markingColor)
                pause(0.001)

            end;

%         hypoTh1; % if no file use the default values

            % ask the user which image came out best
            answer = inputdlg('which figure is best (1-9)','choose best figure');
            bestFig=str2num(char(answer));
            % use best fig to update the thStruct and save the updated one
            loopTh=bestFig
            hypoThUpdate1;
            save thStructSaved thStruct
        end
    end

    thStruct.showValues=1;
    figure

    %%
    % startingImage=4966;
    % endingImage=4966;
    % endingImage=4860;
    % startingImage=4860;
    % endingImage=333;
    warning off
    measurementsVect=[];
    measurementsVectRoots=[];
    lengthHypo=[];
    lengthRoots=[];

    disp('processing')

    for loop=startingImage:endingImage,
        %     close all


        if markingColor~=0,
            fileName=['DSCN' num2str(loop) '.tif'];
            %         fileName=['DSCN' num2str(loop) '.jpg'];
            %         [lengthHypo]=measureHypo2(fileName,markingColor)
            %         [lengthHypo, lengthRoots]=measureHypo4(fileName,markingColor)
            %         [lengthHypo, lengthRoots]=measureHypo5(fileName,markingColor)
            %         [lengthHypo, lengthRoots]=measureHypo6(fileName,markingColor)
            %         [lengthHypo, lengthRoots]=measureHypo8(fileName,markingColor)
            [lengthHypo, lengthRoots]=measureHypo11(fileName,thStruct,markingColor);
        end;

        measurementsVect=[measurementsVect; loop; lengthHypo;];
        measurementsVectRoots=[measurementsVectRoots; loop; lengthRoots;];

        fileName=['lengthsReportHypo' num2str(startingImage) '-' num2str(endingImage) '.txt'];
        fid = fopen(fileName, 'wt');
        fprintf(fid, '%6.2f\n', measurementsVect);
        fclose(fid)
        fileName=['lengthsReportRoots' num2str(startingImage) '-' num2str(endingImage) '.txt'];
        fid = fopen(fileName, 'wt');
        fprintf(fid, '%6.2f\n', measurementsVectRoots);
        fclose(fid)

    end;
    warning on




    %% finish
    cd(oldDir);

    measurementsVect
    measurementsVectRoots

    toc

    disp('finished processing')
catch
    disp('no files selected')

end
