warning off
close all
oldDir=pwd;
knowenDistance=13; % mm
accuracyTh=0.05;

[fnameFirst1,dataPathCalib] = uigetfile('*.tif','Select the first image to use for the calibration');
cd(dataPathCalib);
calibI=imread(fnameFirst1);
figure,
imshow(calibI)
title('image for calibration')
% maximize
message='Click on two adjacent grid point';
% h=msgbox(message);
% pause
% clear(h)
hold on
[x1,y1] = ginput(1);
h1=plot(x1,y1,'.','MarkerSize',16,'Color','b');
[x2,y2] = ginput(1);
h2=plot(x2,y2,'.','MarkerSize',16,'Color','r');
% button = questdlg('Is this ok ?','Verify calibration')
distance=sqrt((x1-x2)^2+(y1-y2)^2);
calibrationRatio1=knowenDistance/distance % this is how many mm in a pixel

[fnameFirst1,dataPathCalib] = uigetfile('*.tif','Select the second image to use for the calibration');
cd(dataPathCalib);
calibI=imread(fnameFirst1);
figure,
imshow(calibI)
title('image for calibration')
% maximize
message='Click on two adjacent grid point';
% h=msgbox(message);
% pause
% clear(h)
hold on
[x1,y1] = ginput(1);
h1=plot(x1,y1,'.','MarkerSize',16,'Color','b');
[x2,y2] = ginput(1);
h2=plot(x2,y2,'.','MarkerSize',16,'Color','r');
% button = questdlg('Is this ok ?','Verify calibration')
distance=sqrt((x1-x2)^2+(y1-y2)^2);
calibrationRatio2=knowenDistance/distance % this is how many mm in a pixel

if abs(calibrationRatio1-calibrationRatio2)/calibrationRatio1<accuracyTh,
    calibrationRatio=mean([calibrationRatio1,calibrationRatio2]);
    save calibrationRatioFile calibrationRatio
    calibrationRatio
    message=['Calibration completed. 1 pixel is: ',num2str(calibrationRatio), ' mm'];
    h=msgbox(message);
else
    errordlg('Sizes do not match, run calibration again','File Error');
end
cd(oldDir)
