%% first skeletonization
BW3 = bwmorph(BW,'skel',Inf);
if showIntermediate,
    figure, imshow(BW3)
end
%% closing and opening

se=strel('disk',5);
morph1=imclose(BW3,se);
if showIntermediate,
    figure, imshow(morph1), title('line 55');
end

% used to be 4 but I changed to 8 so as not to delete diagonal pixels
morph2 = bwareaopen(morph1,2,8);
% morph2 = bwareaopen(morph1,2,4);

if showIntermediate,
    figure, imshow(morph2), title('line 59');
end

%% find objects, filter those with 1 pixel minor axis, skel, close, skel

L = bwlabel(morph2,8);
STATS = regionprops(L,'Area','MinorAxisLength');
minorAxis=cell2mat({STATS.MinorAxisLength});

if showIntermediate,
    figure, imagesc(L), title('line 67');
end

goodObjects=find(minorAxis>2);
badObjects=find(minorAxis<1.2);
morph3=morph2;
for loop=1:length(badObjects),
    morph3(find(L==badObjects(loop)))=0;
end
morph4 = bwmorph(morph3,'skel',Inf);

se=strel('disk',5);
morph5=imclose(morph4,se);
if showIntermediate,
    figure, imshow(morph5), title('line 81');
end

morph6 = bwmorph(morph5,'skel',Inf);
if showIntermediate,
    figure, imshow(morph6)
end
%% find objects, filter out minimal box size and minimal area

L = bwlabel(morph6,8);
STATS = regionprops(L,'Area','Centroid','BoundingBox');
Centroid=cell2mat({STATS.Centroid});
area=cell2mat({STATS.Area});

if showIntermediate,
    figure, imagesc(L)
end

% this enables us to find objects that are straight lines and eliminte them
% they are recognized by being 1 pixels width in some dimension throughout
boundingBox=cell2mat({STATS.BoundingBox}');

if ~isempty(boundingBox),
    boxXWidth=boundingBox(:,3);
    boxYWidth=boundingBox(:,4);
else
    boxXWidth=[];
    boxYWidth=[];
end

minAreaTh=20; % important th - original value
minAreaTh=10; % important th - new value

minBoxYWidthTh=2;
minBoxYWidthTh=10;

% badObjects=find(area'<minAreaTh | boxXWidth<2 | boxYWidth<2);
badObjects=find(area'<minAreaTh | boxXWidth<2 | boxYWidth<minBoxYWidthTh);

morph7=morph6;
for loop=1:length(badObjects),
    morph7(find(L==badObjects(loop)))=0;
end

morph6 = bwmorph(morph7,'skel',Inf);
L = bwlabel(morph6,8);
STATS = regionprops(L,'Area','Centroid');
Centroid=cell2mat({STATS.Centroid});

if showIntermediate,
    figure, imagesc(L)
end
%% connect objects that are one above the other

% make sure that if there aren not hypos you are safe
if ~isempty(boundingBox),

xMat1=repmat(Centroid(1,1:2:end),length(Centroid)/2,1);
xMat2=xMat1';
xDelta=xMat2-xMat1;

yMat1=repmat(Centroid(1,2:2:end),length(Centroid)/2,1);
yMat2=yMat1';
yDelta=yMat2-yMat1;

yDelta(find(yDelta==0))=eps;

ratio=xDelta./yDelta;

else
ratio=[];
end

% this is how you find the pairs
[i,j]=find(abs(ratio)<ratioTh);

% these are the objects to connect
pair1=i(find(i<j));
pair2=j(find(i<j));


STATS = regionprops(L','PixelList');
for loop=1:length(pair1),
    pixels1=STATS(pair1(loop)).PixelList;
    pixels2=STATS(pair2(loop)).PixelList;


    ob1op1=(min(pixels1(:,1)));
    ob1op2=(max(pixels1(:,1)));
    ob2op1=(min(pixels2(:,1)));
    ob2op2=(max(pixels2(:,1)));

    distanceEnds=abs([ob1op1-ob2op1, ob1op1-ob2op2, ob1op2-ob2op1, ob1op2-ob2op2]);
    minPair=find(distanceEnds==min(distanceEnds));
    switch minPair,
        case 1,
            locClose1=find(pixels1(:,1)==ob1op1);
            locClose2=find(pixels2(:,1)==ob2op1);
        case 2,
            locClose1=find(pixels1(:,1)==ob1op1);
            locClose2=find(pixels2(:,1)==ob2op2);
        case 3,
            locClose1=find(pixels1(:,1)==ob1op2);
            locClose2=find(pixels2(:,1)==ob2op1);
        case 4,
            locClose1=find(pixels1(:,1)==ob1op2);
            locClose2=find(pixels2(:,1)==ob2op2);
    end
    loc1=[pixels1(locClose1,1) pixels1(locClose1,2)];
    loc2=[pixels2(locClose2,1) pixels2(locClose2,2)];

    % this addes the missing points that will connect the objects

    % first make sure that you are not coonecting something that is far too
    % distant
    maxDist=40;
    if sqrt((loc1(1)-loc2(1))^2+abs((loc1(2)-loc2(2)))^2)<maxDist,
        % you have to deal seperately with cases where the long axis is X and ones
        % with Y. (2) is X (1) is Y.
        if abs((loc1(1)-loc2(1)))<abs((loc1(2)-loc2(2)))
            % make is such that loc1 is the one with the lower value of the long axis,
            % so that the interpolation will run well
            if loc1(2)-loc2(2)>0,
                locTmp=loc2;
                loc2=loc1;
                loc1=locTmp;
            end
            pointsLong=[loc1(2):loc2(2)];
            pointsShort=interp1( [loc1(2),loc2(2)],[loc1(1),loc2(1)],[loc1(2):loc2(2)]); % the location on the short axis
            for loop=1:length( pointsShort),
                morph6(round(pointsShort(loop)), round(pointsLong(loop)))=1;
            end

        else
            if loc1(1)-loc2(1)>0,
                locTmp=loc2;
                loc2=loc1;
                loc1=locTmp;
            end
            pointsLong=[loc1(1):loc2(1)];
            %             pointsShort=interp1([loc1(1),loc2(1)],[loc1(2),loc2(2)],[loc1(1):loc2(1)]); % the location on the short axis
            % I added an epsilon as an ad hoc solution
            epsilon=0.01;
            pointsShort=interp1([loc1(1),loc2(1)+epsilon],[loc1(2),loc2(2)+epsilon],[loc1(1):loc2(1)]); % the location on the short axis
            for loop=1:length( pointsShort),
                morph6(round(pointsLong(loop)), round(pointsShort(loop)))=1;
            end
        end;
    end;
end

L2 = bwlabel(morph6,8);
if showIntermediate,
    figure, imagesc(L2)
end

%% make a mask for a later overlay

STATS = regionprops(L2,'Area','Centroid');

% create an overlay image
mask=ICropped;
se=strel('disk',5);
L3=imdilate(L2,se);
mask(L3>0)=0;


%% go back to the begining and find markings - first crop image again but
%% this time work with the colored image
% close all
longAxis=size(IFull,2);
shortAxis=size(IFull,1);
aCropped=imcrop(a,[cropSizeXl-1 cropSizeYl-1 longAxis-cropSizeXl-cropSizeXr-1 shortAxis-2*cropSizeYl-cropSizeYr-1]);
if showIntermediate,
    figure, imagesc(aCropped)
end

%% subtract channels, and threshold
if  markingsColor==1,
    %     subtractChannels=(aCropped(:,:,1)-aCropped(:,:,3)); % for red markings
    subtractChannels=(aCropped(:,:,1)-aCropped(:,:,2)); % for red markings
    markingsTh=markingsThRed;
end
if  markingsColor==2,
    subtractChannels=(aCropped(:,:,2)-aCropped(:,:,1)); % for green markings
    markingsTh=markingsThGreen;
end
if  markingsColor==3,
    subtractChannels=(aCropped(:,:,3)-aCropped(:,:,1)); % for blue markings
    markingsTh=markingsThBlue;
end

if  markingsColor==4,
    subtractChannels=(aCropped(:,:,1)-aCropped(:,:,2)); % for red markings
    markingsTh=markingsThRed;
    bwMarksR1=subtractChannels>markingsTh;
    subtractChannels=(aCropped(:,:,2)-aCropped(:,:,1)); % for red markings
    markingsTh=markingsThGreen;
    bwMarksG1=subtractChannels>markingsTh;
    bwMarks1=logical(bwMarksR1+bwMarksG1);
end

if showIntermediate,
    figure, imagesc(subtractChannels), colorbar
end

if markingsColor~=4.
    % for colored markings
    bwMarks1=subtractChannels>markingsTh;
end;


% for black markings
% th=95;
% bwMarks1=aCropped(:,:,1)<th;

if showIntermediate,
    figure, imshow(bwMarks1)
end


%% subtract segmented from markers
se=strel('disk',3);
BWSub1=imdilate(BW,se);

bwMarks4=imsubtract(bwMarks1,BWSub1);
bwMarks4(find(bwMarks4<0))=0;
if showIntermediate,
    figure, imshow(bwMarks4)
end


%% filter short lines

LMarks1 = bwlabel(bwMarks4,8);
STATS = regionprops(LMarks1,'BoundingBox');
boundingBox=cell2mat({STATS.BoundingBox}');

if ~isempty(boundingBox),
    boxXWidth=boundingBox(:,3);
    boxYWidth=boundingBox(:,4);
else
    boxXWidth=[];
    boxYWidth=[];
end

if showIntermediate,
    figure, imagesc(LMarks1), title('line 67');
end

% threshold for a minimal width of the marker in teh x direction
thXBox=4;

goodObjects=find(boxXWidth>thXBox);
badObjects=find(boxXWidth<thXBox);
bwMarks2=bwMarks4;
for loop=1:length(badObjects),
    bwMarks2(find(LMarks1==badObjects(loop)))=0;
end
if showIntermediate,
    figure, imshow(bwMarks2)
end


%% open
morph2 = bwareaopen(bwMarks2,8,4);

% until here

% morph2 = bwareaopen(morph1,2,4);

if showIntermediate,
    figure, imshow(morph2), title('find marks after one opening');
end

%% dilate lines
se = strel('line',15,0);
% change
se = strel('line',20,0);
% se = strel('disk',25);
% morph3 = imclose(morph2,se);
morph3 = imdilate(morph2,se);
% morph2 = bwareaopen(morph1,2,4);

if showIntermediate,
    figure, imshow(morph3), title('find marks after closing');
end

%% skeleton resulting lines

BW3 = bwmorph(morph3,'skel',Inf);
if showIntermediate,
    figure, imshow(BW3)
end

%% find where yellow intersects markings and only these markings increase

intersectI=immultiply(~mask,BW3);
if showIntermediate,
    figure,    imshow(intersectI);
end


%% subtract marks from image, find objects

morph10=morph6-immultiply(morph6,intersectI);

% morph10=morph6-immultiply(morph6,intersectI3);

if showIntermediate,
    figure, imshow(morph10)
end

L4 = bwlabel(morph10,8);
if showIntermediate,
    figure, imagesc(L4)
end

%% collect data, filter by minimal area
STATS = regionprops(L4,'Area','Centroid');
area=cell2mat({STATS.Area});

% minAreaTh=50; % original value
minAreaTh=10; % that is equivalent to about 1.5 mm
minAreaTh=15; % I try a higher value

maxAreaTh=210; % A suggestion for an upper value
% maxAreaTh=1400; % A suggestion for an upper value

badObjects=find(area'<minAreaTh | area'>maxAreaTh);
morph11=morph10;
for loop=1:length(badObjects),
    morph11(find(L4==badObjects(loop)))=0;
end



%% take off objects that are one below the other
L10 = bwlabel(morph11,8);
if showIntermediate,
    figure, imagesc(L10)
end
STATS = regionprops(L10,'Area','Centroid');
Centroid=cell2mat({STATS.Centroid});
Area=cell2mat({STATS.Area});

if showIntermediate,
    figure, imagesc(L10)
end

xMat1=repmat(Centroid(1,1:2:end),length(Centroid)/2,1);
xMat2=xMat1';
xDelta=xMat2-xMat1;

yMat1=repmat(Centroid(1,2:2:end),length(Centroid)/2,1);
yMat2=yMat1';
yDelta=yMat2-yMat1;

yDelta(yDelta==0)=eps;

ratio=xDelta./yDelta;

% this is how you find the pairs
[i,j]=find(abs(ratio)<ratioTh);

% these are the objects to connect
pair1=i(find(i<j));
pair2=j(find(i<j));

badObjects=[];
% filter pairs either by taking the one with largest size or some position
% based info (top/bottom)
% goodObjects=find(boxXWidth>thXBox);
for loop=1:length(pair1),
    %     if yMat1(1,pair1(loop))>yMat1(1,pair2(loop)),
    if Area(pair1(loop))<Area(pair2(loop)),
        badObjects=[badObjects, pair1(loop)];
    else
        badObjects=[badObjects, pair2(loop)];
    end
end

morph12=morph11;
for loop=1:length(badObjects),
    morph12(find(L10==badObjects(loop)))=0;
end
% showIntermediate=1;
if showIntermediate,
    figure, imshow(morph12)
end



%%

L5 = bwlabel(morph12,8);
if showIntermediate,
    figure, imagesc(L5)
end
STATS = regionprops(L5,'Area','Centroid');

%% dilate shoots
mask2=ICropped;
se = strel('line',5,0);
L6 = imdilate(L5,se);
mask2(L6>0)=0;

if showIntermediate,
    figure, imshow(logical(L6));
end

if showIntermediate,
    figure, imshow(BW3);
    figure, imshow(mask2);
end
%% create an overlay image, add sizes


% clear old data just in case
clear PerimeterPixels

% mask3 will collect the measured images
mask3=zeros(size(mask2));
for loop=1:length(STATS),
    [j,i]=find(L5==loop);
    oneRootImage=zeros(size(L5));
    oneRootImage(find(L5==loop))=1;
%     PerimeterPixels(loop) = EstimatePerimeter(oneRootImage);
    [PerimeterPixels(loop),measuredHypo] = EstimatePerimeterRon(oneRootImage);
    mask3=mask3+measuredHypo(:,:,1);
end

% mask2=ICropped;

mask3=uint8(mask3);
LMeasuredHypo = bwlabel(mask3,8);

se = strel('line',5,0);
LMeasuredHypoDilated = imdilate(LMeasuredHypo,se);

% mask2(L6>0)=0;





% changed
Isum(:,:,2)=mask3+uint8(128*double(BW3)); % with markers
% Isum(:,:,2)=mask2;% without markers
Isum(:,:,3)=mask3;
Isum(:,:,1)=ICropped;


perimeterVect=PerimeterPixels*conversionRatio;
% these are values up to one digit after decimal point
lengthStemVect=round(10*perimeterVect)/10;

if showIntermediate,

    figure, imshow(Isum)
%     figure, imshow(measuredHypo(:,:,1))
    for loop=1:length(STATS),
        [j,i]=find(L5==loop);
        %     text(i(round(length(i)/2)),j(round(length(i)/2)),num2str(STATS(loop).Area),'Color','b','FontSize',14)
        % show stem length instead of area, using a simlpe calibration
        lengthStem=lengthStemVect(loop);
        text(i(round(length(i)/2))+6,j(round(length(i)/2)),num2str(lengthStem),'Color','y','FontSize',14)
        % show object index instead of area
        %     text(i(round(length(i)/2)),j(round(length(i)/2)),num2str(loop),'Color','b','FontSize',14)
    end
    title('absolute calibration');
    maximize

    disp(lengthStemVect')
end
lengthHypo=lengthStemVect';
